QuantLib: Coupon Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.12

Public Member Functions | Protected Attributes | List of all members
Coupon Class Referenceabstract

coupon accruing over a fixed period More...

`#include <ql/cashflows/coupon.hpp>`

Inheritance diagram for Coupon:
[legend]

## Public Member Functions
| Coupon (const Date &paymentDate, Real nominal, const Date &accrualStartDate, const Date &accrualEndDate, const Date &refPeriodStart=Date(), const Date &refPeriodEnd=Date(), const Date &exCouponDate=Date())
Event interface
Date | date () const
CashFlow interface
Date | exCouponDate () const
| returns the date that the cash flow trades exCoupon
Inspectors
virtual Real | nominal () const
const Date & | accrualStartDate () const
| start of the accrual period
const Date & | accrualEndDate () const
| end of the accrual period
const Date & | referencePeriodStart () const
| start date of the reference period
const Date & | referencePeriodEnd () const
| end date of the reference period
Time | accrualPeriod () const
| accrual period as fraction of year
Date::serial_type | accrualDays () const
| accrual period in days
virtual Rate | rate () const =0
| accrued rate
virtual DayCounter | dayCounter () const =0
| day counter for accrual calculation
Time | accruedPeriod (const Date &) const
| accrued period as fraction of year at the given date
Date::serial_type | accruedDays (const Date &) const
| accrued days at the given date
virtual Real | accruedAmount (const Date &) const =0
| accrued amount at the given date
Visitability
virtual void | accept (AcyclicVisitor &)
Public Member Functions inherited from CashFlow
bool | hasOccurred (const Date &refDate=Date(), boost::optional< bool > includeRefDate=boost::none) const
| returns true if an event has already occurred before a date More...
virtual Real | amount () const =0
| returns the amount of the cash flow More...
bool | tradingExCoupon (const Date &refDate=Date()) const
| returns true if the cashflow is trading ex-coupon on the refDate
Event interface
Visitability
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Protected Attributes
Date | paymentDate_
Real | nominal_
Date | accrualStartDate_
Date | accrualEndDate_
Date | refPeriodStart_
Date | refPeriodEnd_
Date | exCouponDate_
Real | accrualPeriod_

## Detailed Description

coupon accruing over a fixed period

This class implements part of the CashFlow interface but it is still abstract and provides derived classes with methods for accrual period calculations.

Examples:
  BermudanSwaption.cpp.

## Constructor & Destructor Documentation

## ◆ Coupon()

Coupon | ( | const Date & | paymentDate,
|  | Real | nominal,
|  | const Date & | accrualStartDate,
|  | const Date & | accrualEndDate,
|  | const Date & | refPeriodStart = `Date()`,
|  | const Date & | refPeriodEnd = `Date()`,
|  | const Date & | exCouponDate = `Date()`
| ) |  |

Warning:
  the coupon does not adjust the payment date which must already be a business day.

## Member Function Documentation

## ◆ date()

Date date | ( |  | ) | const
| virtual

Note
  This is inherited from the event class

Implements CashFlow.